/*
	BlueTechButton
    
    This class wraps the BlueTechButtonSymbol class via composition.
    This class exposes the Flash button's powers to any classes,
    or components that want to use it without having to know
    about the internals of the MovieClip.  Additionally,
    since it extends UIComponent, it follows the same interface,
    and hardcodes the SWF's measurement sizes.
    
    Created by Jesse R. Warden a.k.a. "JesterXL"
	jesterxl@jessewarden.com
	http://www.jessewarden.com
	http://www.universalmind.com
	
	This is release under a Creative Commons license. 
    More information can be found here:
    
    http://creativecommons.org/licenses/by/2.5/
*/

package com.jxl
{
	import flash.events.MouseEvent;
	import mx.core.UIComponent;
	import com.jxl.BlueTechButtonSymbol;

	[Event(name="click", type="flash.events.MouseEvent")]
	public class BlueTechButton extends UIComponent
	{
		public function get label():String
		{
			return __label;
		}
		
		public function set label(val:String):void
		{
			if(val != __label)
			{
				__label = val;
				__labelDirty = true;
				// this calls commitProperties 1 frame later basically
				invalidateProperties();
			}
		}
		
		protected var __blueTechButton:BlueTechButtonSymbol;
		
		protected var __labelDirty:Boolean = false;
		protected var __label:String = "";
		
		public function BlueTechButton()
		{
			super();
		}
		
		protected override function createChildren():void
		{
			super.createChildren();
			
			if(__blueTechButton == null)
			{
				// attach the Flash button, and set it's label
				__blueTechButton = new BlueTechButtonSymbol();
				__blueTechButton.x = 0;
				__blueTechButton.y = 0;
				__blueTechButton.setLabel(__label);
				// add it to the DisplayList so it's visible
				addChild(__blueTechButton);
			}
		}
		
		protected override function commitProperties():void
		{
			super.commitProperties();
			
			if(__labelDirty == true)
			{
				__labelDirty = false;
				// if the label has changed, update the text
				// in the Flash button
				__blueTechButton.setLabel(__label);
			}
		}
		
		protected override function measure():void
		{
			// the MovieClip in Flash is 100x22; hardcode for now
			measuredWidth = 100;
			measuredHeight = 22;
		}
		
	}
}